﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	'#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public bc As ByteConverter
	Dim delai_collecte As Int= 5 'untité mn
	Private service_battery As String="0000180f-0000-1000-8000-00805f9b34fb"
	Private Level_battery As String="00002a19-0000-1000-8000-00805f9b34fb"
	Private service_Temperature As String="226c0000-6476-4566-7562-66734470666d"
	Private Temperature As String="226caa55-6476-4566-7562-66734470666d"
	Private Temp_sensor As String=""
	Private Hydro_sensor As String=""
	
	Private phone1 As Phone
	Dim notif_mess As NB6
	Dim notif_sensor As Notification
	
	Dim list_data_temp As List
	Dim Id_sensor As String
	Dim Local_sensor As String
	Dim Mac_Adress_Sensor As String
	Dim Offset_temp As String=""
	Dim oompteur_sensor As Int=0
	Dim endofmesure As Boolean=False
	Dim local_Home As String=""
	Dim Ident_Sensor As String=""
	
	Dim Timer1 As Timer
	Dim delay As Int
	
	Dim process_http As HttpJob
	
End Sub

Sub Service_Create
	
	manager.Initialize("manager")
	
	list_data_temp.Initialize
	process_http.Initialize("",Me)
	endofmesure=False
	
	Timer1.Initialize("timer1", 1000)
	
	
	
	
	Dim folder As String = rp.GetSafeDirDefaultExternal("shared")
	
	' intialisation des notifications
	Dim show_icon As Bitmap
	show_icon= LoadBitmapResize(File.DirAssets, "Logo_MM.png", 32dip, 32dip, False)
	notif_mess.Initialize("custom sound1", Application.LabelName, "DEFAULT").AutoCancel(True).BadgeIconType("LARGE")
	notif_mess.SmallIcon(show_icon)
	notif_mess.SetDefaults(True, True, False)
	'notif_mess.CustomSound(CreateFileProviderUri(folder, "intuition.mp3"))
	
	
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
End Sub

Sub CreateFileProviderUri (Dir As String, FileName As String) As Object
	Dim FileProvider As JavaObject
	Dim context As JavaObject
	context.InitializeContext
	FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim f As JavaObject
	f.InitializeNewInstance("java.io.File", Array(Dir, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	'Initialisation et lancement du scan
	
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
				
		'Chargement de la liste des sensors
		
		Param.read_file_setup("setup.txt")
		Timer1.Enabled = True
		manager.scan(Null)
			
	End If
		
End Sub

Sub scan_Sensor
	manager.scan2(Null,False)
End Sub

Sub Timer1_Tick
	
	delay=delay+1
	
	If delay > 30 Then 'Si le délai d'attente de scan est >30s alors on stoppe le scan 
		'Timer1.Enabled=False
		delay=0
		endofmesure=True
		manager.StopScan
		Upload_file
		End_service
	End If
	
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
'	If Id="D4:5B:56:D3:46:06" Then
'		Dim data1() As Byte = AdvertisingData.Get(1)
'		Dim data2() As Byte = AdvertisingData.Get(-1)
'		Dim data3() As Byte = AdvertisingData.Get(0)
'		'you can use byte converter to convert to hex if you like:
'		Dim bc As ByteConverter
'		Log(bc.HexFromBytes(data1))
'		'Log(bc.HexFromBytes(data2))
'		Log(bc.HexFromBytes(data3))
'	End If
	
	
	If  Name="MJ_HT_V1"  Then 'Filtrage sur le modèle de sensor
		delay=0 'Remise à zéro du timeout
		For Each sensors_list As String In Param.list_Read 'ennumere la liste des sensors
			Dim sensors_list1() As String= Regex.Split(";",sensors_list)
			
			If sensors_list1.Length=4 Then
				If Id=sensors_list1(2) Then 'recherche l'adresse MAc correspondante aux sensors connus
					oompteur_sensor=oompteur_sensor+1
					manager.Connect2(Id,False) 'disabling auto connect can make the connection quicker
					Id_sensor =sensors_list1(0)
					Local_sensor= sensors_list1(1)
					Mac_Adress_Sensor=sensors_list1(2)
					Offset_temp=sensors_list1(3)
				End If
			End If
			
			If sensors_list1.Length=1 Then 'récupère le lieu de la maison
				If sensors_list1(0).Contains("[") Then
					local_Home=sensors_list1(0)
				End If
			End If
			
		Next
		
		' Si tous les sensors ont été scannés alors on quitte le scan. (TimeOut= 30s)
		If oompteur_sensor = Param.list_Read.Size-1 Then 'arrête le scan si tous les sensors ont été identifiés
			endofmesure=True
			manager.StopScan
		End If
			
	End If
	
End Sub

Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

'Sub DataAvailable (Service1 As String, Characteristics As Map)
'	'
'	For Each id As String In Characteristics.Keys
'	'
'		'
'		Log(Service1)
'		Log(id & ";" & Characteristics.Get(id))
'	Next			
'	'
'End Sub

Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	
End Sub


Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	For Each id As String In Characteristics.Keys
		Dim value() As Byte=Characteristics.Get(id)
		If ServiceId=service_battery Then
			
			Log("Level Battery : " & value(0) & "%")
		Else
			Log(BytesToString(value, 0, value.Length, "UTF8"))
			Dim data_sensor() As String= Regex.Split(" ", BytesToString(value, 0, value.Length, "UTF8"))
			Temp_sensor=data_sensor(0)
			Hydro_sensor=data_sensor(1)
		End If
	Next
End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	notif_sensor = notif_mess.Build("Sensor Salle" ,Temp_sensor,"Mess_off",Main)
	notif_sensor.Notify(1)
	list_data_temp.Add(Id_sensor & ";" & Local_sensor & ";" & Mac_Adress_Sensor & ";" & Temp_sensor & ";" & Hydro_sensor & ";" & Offset_temp)
	
	' function send files on Cloud to be defined
	
	
	
	
	If endofmesure=True Then
		Upload_file
		End_service
	End If
	
End Sub

Sub Upload_file
	
End Sub


Sub Manager_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	'ReadData
	manager.SetNotify(service_Temperature,Temperature,True)
		
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub End_service
	
	StartServiceAt(Me,DateTime.Now + delai_collecte*60000,True) 'programmation redemarrage du service
	
	If phone1.SdkVersion>=26 Then
		Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
		Else
			StopService(Me)
	End If
End Sub


Sub Service_Destroy
	
End Sub
